﻿using Telerik.Windows.Documents.Model;
using System.Windows.Controls;
using System.Windows;
using Telerik.Windows.Documents.FormatProviders.Pdf;
using System.IO;

namespace InsertCustomControl
{
    public partial class MainPage : UserControl
    {
        private RadDocument document;

        public MainPage()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            document = CreateDocumentWithCustomControls();
        }

        public RadDocument CreateDocumentWithCustomControls()
        {
            RadDocument doc = new RadDocument();

            Section section = new Section();
            doc.Sections.Add(section);

            doc.SectionDefaultPageMargin = new Telerik.Windows.Documents.Layout.Padding(10,10,10,10);

            Paragraph paragraph = new Paragraph();
            section.Blocks.Add(paragraph);

            Span span = new Span("Some text before the button...");
            span.FontSize = 30;
            paragraph.Inlines.Add(span);

            Button button = new Button();
            button.Content = "The Button";
            button.Width = 100;
            button.Height = 50;

            button.Click += ShowMessageBox;

            InlineUIContainer container = new InlineUIContainer();
            container.UiElement = button;
            container.Width = button.Width;
            container.Height = button.Height;

            paragraph.Inlines.Add(container);

            Span span2 = new Span("Some text after...");
            paragraph.Inlines.Add(span2);

            return doc;               
        }

        public void ShowMessageBox(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Your button was just clicked!");
        }

        private void buttonExportToPDF_Click(object sender, RoutedEventArgs e)
        {
            ExportToPdf(document);
        }

        private void buttonLoadDocumentInEditor_Click(object sender, RoutedEventArgs e)
        {
            this.editor.Document = document;
        }

          public void ExportToPdf(RadDocument document)
        {
            SaveFileDialog dialog = new SaveFileDialog();
            if (dialog.ShowDialog() == true)
            {
                using (Stream stream = dialog.OpenFile())
                {
                    PdfFormatProvider provider = new PdfFormatProvider();
                    provider.Export(document, stream);
                }
            }
        }

   }
}
